import java.awt.Color;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.GridLayout;
import java.awt.Panel;

class Komplex { // eigentlich public

	private double realTeil;
	private double imaginaerTeil;

	public Komplex() {
		this(0.0, 0.0);
	}

	public Komplex(double re, double imag) {
		this.realTeil = re;
		this.imaginaerTeil = imag;
	}

	public Komplex(Komplex kompl) {
		this(kompl.realTeil, kompl.imaginaerTeil);
	}

	public boolean istIdentisch(Komplex kompl) {
		return this.realTeil == kompl.realTeil
				&& this.imaginaerTeil == kompl.imaginaerTeil;
	}

	public String makeString() {
		return this.realTeil + " + " + this.imaginaerTeil + "i";
	}

	public double getRealTeil() {
		return this.realTeil;
	}

	public double getImaginaerTeil() {
		return this.imaginaerTeil;
	}

	public static Komplex add(Komplex kompl1, Komplex kompl2) {
		return new Komplex(kompl1.realTeil + kompl2.realTeil,
				kompl1.imaginaerTeil + kompl2.imaginaerTeil);
	}

	public Komplex add(Komplex kompl) {
		this.realTeil = this.realTeil + kompl.realTeil;
		this.imaginaerTeil = this.imaginaerTeil + kompl.imaginaerTeil;
		return this;
	}

	public static Komplex mult(Komplex kompl1, Komplex kompl2) {
		return new Komplex(kompl1.realTeil * kompl2.realTeil
				- kompl1.imaginaerTeil * kompl2.imaginaerTeil, kompl1.realTeil
				* kompl2.imaginaerTeil + kompl1.imaginaerTeil * kompl2.realTeil);
	}

	public Komplex mult(Komplex kompl) {
		Komplex tmp = Komplex.mult(this, kompl);
		this.realTeil = tmp.realTeil;
		this.imaginaerTeil = tmp.imaginaerTeil;
		return this;
	}

}

public class UE15Aufgabe16 extends Frame {

	public UE15Aufgabe16() {
		super("MandelbrotMenge");
		this.setLayout(new GridLayout(1, 1));
		Panel p = new DrawPanel();
		this.add(p);
		this.setBounds(20, 20, 488, 464);
		this.setVisible(true);
	}

	public static void main(String[] args) {
		new UE15Aufgabe16();
	}
}

class DrawPanel extends Panel {

	// C-Werte checken nach Zn+1 = Zn^2 + C, Zo = 0. 50 Iterationen.
	public int checkC(Komplex c) {
		Komplex z = new Komplex(0.0, 0.0);
		Komplex z_minus1 = new Komplex();
		int i;
		for (i = 0; i < 50; i++) {
			z = Komplex.add(Komplex.mult(z_minus1, z_minus1), c);
			if (z.getRealTeil() * z.getRealTeil() + z.getImaginaerTeil()
					* z.getImaginaerTeil() > 4) {
				return i;
			}
			z_minus1 = new Komplex(z);
		}
		return i;
	}

	// Punkte berechnen und setzen
	@Override
	public void paint(Graphics g) {
		double zelle = 0.00625; // Ein Pixel = 0.00625
		Color colAppleman = new Color(0, 0, 180); // Farbe Apfelmaennchen

		Komplex c = new Komplex(0.0, -1.35);
		for (int y = 0; y < 430; y++) {
			c = new Komplex(-2.0, c.getImaginaerTeil());
			for (int x = 0; x < 480; x++) {
				int iterationenC = this.checkC(c);
				if (iterationenC == 50) {
					g.setColor(colAppleman);
					g.drawLine(x, y, x, y);
				} else {
					Color colPeriphery = new Color(
							255 - iterationenC % 2 * 125,
							255 - iterationenC % 7 * 36,
							255 - iterationenC % 3 * 85);
					g.setColor(colPeriphery); // Farbe Umgebung
					g.drawLine(x, y, x, y);
				}
				c.add(new Komplex(zelle, 0));
			}
			c.add(new Komplex(0.0, zelle));
		}
	}
}
