class PriorityQueue { // eigentlich public

	private int[] zahlen;
	private int aktuellerIndex;

	public PriorityQueue(int max) {
		this.zahlen = new int[max];
		this.aktuellerIndex = 0;
	}

	public boolean isEmpty() {
		return this.aktuellerIndex == 0;
	}

	public boolean isFull() {
		return this.aktuellerIndex == this.zahlen.length;
	}

	public void insert(int elem) {
		if (!this.isFull()) {
			this.zahlen[this.aktuellerIndex++] = elem;
		}
	}

	public int remove() {
		if (!this.isEmpty()) {
			int max = this.zahlen[0];
			int maxIndex = 0;
			for (int i = 1; i < this.aktuellerIndex; i++) {
				if (this.zahlen[i] > max) {
					max = this.zahlen[i];
					maxIndex = i;
				}
			}
			for (int i = maxIndex; i < this.aktuellerIndex - 1; i++) {
				this.zahlen[i] = this.zahlen[i + 1];
			}
			this.aktuellerIndex--;
			return max;
		} else {
			return -1; // Fehlerbehandlung erfolgt spaeter mit Exceptions
		}
	}
}

public class UE15Aufgabe5 {

	// Testprogramm
	public static void main(String[] args) {
		PriorityQueue queue = new PriorityQueue(2);
		int zahl = IO.readInt("Zahl: ");
		while (zahl != 0) {
			if (!queue.isFull()) {
				queue.insert(zahl);
			}
			zahl = IO.readInt("Zahl: ");
		}
		while (!queue.isEmpty()) {
			System.out.println(queue.remove());
		}
	}

}
